<?php
 if(!defined('ABSPATH')) {
    exit;
 }
?>

      <div class="ipwrap" id="ip_approval_changelogs" style="display:none">
        <h2 class="ip_approval-title"><?php echo __('IP Address Approval Change Logs', 'ip-address-approval'); ?></h2>
                <table class="form-table">
                    <tbody>
                        <tr valign="middle" class="ip-tr-colorbox">
                            <th colspan="2"></th>
                        </tr>
                        <tr valign="top">
                            <th><?php echo __('Change Logs', 'ip-address-approval'); ?></th>
                            <td>

                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.6.0 (9/29/2022)
                              </h3>
                              <div class="ip-log-type newfeatures">
                                <strong>
                                    <?php echo __('New Features', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('You can now Block Proxy, VPN or Tor visitor connections and Block Hosting or Data Center visitor connections and redirect them to their respective pages. In addition you can now Allow or Block Bots (see our <a href="https://www.ip-approval.com/instructions" targrt="_blank">instruction page</a> for details)..', 'ip-address-approval'); ?>
                                </li>
                              </ul>

                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.5.3 (8/18/2022)
                              </h3>
                              <div class="ip-log-type improve">
                                <strong>
                                    <?php echo __('Improved', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Improved: We replaced the Cookie counter code that was used to stop the infinate banned page refreshes, with code that checks to see if the banned page is the page being visited (the cookie counter was letting some people though if they excessively refreshed a page).', 'ip-address-approval'); ?>
                                </li>
                              </ul>

                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.5.2 (11/24/2021)
                              </h3>
                              <div class="ip-log-type bugfixes">
                                <strong>
                                    <?php echo __('Fixed', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Fixed: When using the free version of our service, save changes was was throwing a API Response error for uneditable inputs.', 'ip-address-approval'); ?>
                                </li>
                              </ul>

                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.5.1 (11/16/2021)
                              </h3>
                              <div class="ip-log-type improve">
                                <strong>
                                    <?php echo __('Improved', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Improved: When using the Search Filter the cells containing the filtered term will highlighted.', 'ip-address-approval'); ?>
                                </li>
                              </ul>

                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.4.5 (11/04/2021)
                              </h3>
                              <div class="ip-log-type bugfixes">
                                <strong>
                                    <?php echo __('Bug Fixes', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Fixed: When using the Search Filter on mobile devices, the filtered results were not being hidden due to display: block !important; in the css.', 'ip-address-approval'); ?>
                                </li>
                              </ul>

                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.4.4 (07/11/2021)
                              </h3>
                              <div class="ip-log-type bugfixes">
                                <strong>
                                    <?php echo __('Bug Fixes', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Fixed: When using the free version of our service, save changes was was throwing a API Response error for uneditable inputs.', 'ip-address-approval'); ?>
                                </li>
                              </ul>

                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.4.3 (10/25/2020)
                              </h3>
                              <div class="ip-log-type bugfixes">
                                <strong>
                                    <?php echo __('Bug Fixes', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Fixed: When using the Search Filter on the Site Visitors log, checking the "Check All" checkboxes will now only check the boxes for the visible filtered results.', 'ip-address-approval'); ?>
                                </li>
                              </ul>


                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.4.2 (10/23/2020)
                              </h3>
                              <div class="ip-log-type improve">
                                <strong>
                                    <?php echo __('Improved', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('The page will now scroll up when clicking Delete, Paginate and Per Page on the Site Visitors tab.', 'ip-address-approval'); ?>
                                </li>
                              </ul>


                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.4.1 (4/22/2020)
                              </h3>
                              <div class="ip-log-type bugfixes">
                                <strong>
                                    <?php echo __('Bug Fixes', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Fixed: Access Denied and Banned pages not being created after connecting account.', 'ip-address-approval'); ?>
                                </li>
                              </ul>


                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.4.0 (4/17/2020)
                              </h3>
                              <div class="ip-log-type bugfixes">
                                <strong>
                                    <?php echo __('Bug Fixes', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Fixed: Link in the WP Admin to the IP Approval Settings was being duplicated.', 'ip-address-approval'); ?>
                                </li>
                              </ul>
                              <div class="ip-log-type improve">
                                <strong>
                                    <?php echo __('Improved', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Added link on Plugins page to WordPress IP Editor Instructions.', 'ip-address-approval'); ?>
                                </li>
                                <li>
                                 <?php echo __('Added link in the IP Plugin page tabs to WordPress IP Editor Instructions.', 'ip-address-approval'); ?>
                                </li>
                                <li>
                                 <?php echo __('Added link on Plugins page to our Support.', 'ip-address-approval'); ?>
                                </li>
                              </ul>
                              <div class="ip-log-type changes">
                                <strong>
                                  <?php echo __('Changes', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                  <?php echo __('The Geo Location tab has moved to the right, and changed from the title "Geo Location" to a Globe Icon.', 'ip-address-approval'); ?>
                                </li>
                                <li>
                                  <?php echo __('The "Changelogs" tab title has changed to "Change Logs".', 'ip-address-approval'); ?>
                                </li>
                                <li>
                                  <?php echo __('The "IP Approval Credentials" tab title has changed to "Credentials".', 'ip-address-approval'); ?>
                                </li>
                              </ul>


                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.3.0 (3/10/2020)
                              </h3>
                              <div class="ip-log-type improve">
                                <strong>
                                    <?php echo __('Improved', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Speed and Code Improvements. We want you, in the WordPress Admin, and your website visitors to have the quickest load times possible.', 'ip-address-approval'); ?>
                                </li>
                              </ul>
                              <div class="ip-log-type newfeatures">
                                <strong>
                                    <?php echo __('New Features', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('"System Info", an option that can be used to see some of the Server and WordPress Environment. It is here if you would ever need it.', 'ip-address-approval'); ?>
                                </li>
                                <li>
                                 <?php echo __('Using CTRL+s keys on a Windows computer (or Command+S on Mac) will Save your changes.', 'ip-address-approval'); ?>
                                </li>
                              </ul>
                              <div class="ip-log-type bugfixes">
                                <strong>
                                    <?php echo __('Bug Fixes', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Fixed: Site Visitors Log "Per Page" feature not allowing the option for "20" to be selected.', 'ip-address-approval'); ?>
                                </li>
                              </ul>


                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.2.3 (3/08/2020)
                              </h3>
                              <div class="ip-log-type bugfixes">
                                <strong>
                                    <?php echo __('Bug Fixes', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Actually Fixed: The ver X.X.X in the upper right corner of the plugins General Settings tab was not being updated.', 'ip-address-approval'); ?>
                                </li>
                              </ul>


                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.2.2 (3/08/2020)
                              </h3>
                              <div class="ip-log-type bugfixes">
                                <strong>
                                    <?php echo __('Bug Fixes', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Fixed: The ver X.X.X in the upper right corner of the plugins General Settings tab was not being updated.', 'ip-address-approval'); ?>
                                </li>
                                <li>
                                 <?php echo __('Fixed: Sections accordion feature not resetting.', 'ip-address-approval'); ?>
                                </li>
                              </ul>


                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.2.1 (3/08/2020)
                              </h3>
                              <div class="ip-log-type bugfixes">
                                <strong>
                                    <?php echo __('Bug Fixes', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Fixed Uncaught Error: Call to undefined function ip_approval_get_ip().', 'ip-address-approval'); ?>
                                </li>
                              </ul>


                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.2.0 (3/07/2020)
                              </h3>
                              <div class="ip-log-type newfeatures">
                                <strong>
                                    <?php echo __('New Features', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('You can now toggle the WORDPRESS SITE SETTINGS and IP APPROVAL SETTINGS sections open and closed.', 'ip-address-approval'); ?>
                                </li>
                              </ul>
                              <div class="ip-log-type improve">
                                <strong>
                                    <?php echo __('Improved', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                 <?php echo __('Added language support to the Plugin.', 'ip-address-approval'); ?>
                                </li>
                              </ul>
                              </h3>
                              <div class="ip-log-type changes"><strong>Changes</strong></div>
                              <ul>
                                <li>
                                  <?php echo __('The IP Approval Credentials tab has been moved to the end.', 'ip-address-approval'); ?>
                                </li>
                              </ul>


                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.1.0 (2/04/2020)
                              </h3>
                              <div class="ip-log-type changes"><strong>Changes</strong></div>
                              <ul>
                                <li>
                                  <?php echo __('The "Restrict Access on the Admin Login Page" checkbox will now only allow visitors listed in the "Allowed" (Remain Open for) list.', 'ip-address-approval'); ?>
                                </li>
                              </ul>


                              <h3 class="ip-log-ver">
                                <?php echo __('Version', 'ip-address-approval'); ?>  1.0.0 (1/24/2020)
                              </h3>
                              <div class="ip-log-type changes">
                                <strong>
                                  <?php echo __('Changes', 'ip-address-approval'); ?>
                                </strong>
                              </div>
                              <ul>
                                <li>
                                  <?php echo __('Released the IP Address Approval Plugin', 'ip-address-approval'); ?>
                                </li>
                              </ul>


                             <!--
                            <h3 class="ip-log-ver">Version  1.0.0 (Mar 1, 2019) </h3>
                            <div class="ip-log-type newfeatures"><strong>New Features</strong></div>
                            <ul><li>Released Plugin</li></ul>

                            <h3 class="ip-log-ver">Version  1.0.0 (Mar 1, 2019) </h3>
                            <div class="ip-log-type improve"><strong>Improved</strong></div>
                            <ul><li>Released Plugin</li></ul>

                            <h3 class="ip-log-ver">Version  1.0.0 (Mar 1, 2019) </h3>
                            <div class="ip-log-type bugfixes"><strong>Bug Fixes</strong></div>
                            <ul><li>Released Plugin</li></ul>

                            <h3 class="ip-log-ver">Version  1.0.0 (Mar 1, 2019) </h3>
                            <div class="ip-log-type remove"><strong>Removed</strong></div>
                            <ul><li>Released Plugin</li></ul>
                             -->

                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                                <br />
                            </td>
                        </tr>
                    </tbody>
                </table>
      </div>